<template>
    <div>
        <div class="position-sticky d-flex justify-content-left align-items-center px-3">
            <div class="d-flex align-items-left _animation-fade" style="margin-top: -2em">
                <a href="" @click.prevent="$router.back()" class="_back-button">
                    <span class="d-flex align-items-center">
                        <i class="bi bi-chevron-left"></i> Back
                    </span>
                </a>
            </div>
        </div>
        <div class="_window d-flex justify-content-center align-items-center">
            <div class="_window-content m-2 p-2 ">
                <CredentialView :credential="credential" class="p-3"></CredentialView>
                <div class="_button mb-5 mx-5 text-center">
                    <a href="#copy" class="btn btn-secondary col-12 mb-3" @click="onCopy"><i class="bi bi-files me-3"></i>Copy Credential</a>
                    <a href="#compliance" class="btn btn-secondary col-12 mb-3" @click="Compliance"><i class="bi bi-files me-3"></i>Pass compliance</a>
                    <a class="btn btn-danger col-12 mb-3" @click="deleteCredential"><i class="bi bi-trash me-3"></i>{{$t('CREDENTIAL.DELETE')}}</a>
                    <span v-if="this.coppied" class="text-secondary _fadin">Credential coppied to your clipboard</span>
                    <span v-if="this.passed" class="text-secondary _fadin">Compliance has been passed successfully</span>
                    <span v-if="this.deleted" class="text-secondary _fadin">Deleted Credential Successfully</span>
                    <span v-if="this.onDelete" class="text-secondary _fadin">
                        <img src="dark-loader.gif" width="30px" style="opacity: 0.9" />
                    </span>
                    <span v-if="this.onDelete" class="text-danger _fadin">Deleting the credential...</span>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import { copyText } from 'vue3-clipboard'
//import { v4 as uuidv4 } from 'uuid'
export default {
  name: 'Credential',
  data() {
    return {
      credentialContent: '',
      coppied: false,
      onDelete: false,
      deleted: false,
      passed:false,
    }
  },
  async asyncData ({ $axios, query }) {
    // TODO: select DID to use
    const credList = await $axios.$get("/api/wallet/credentials/list", { params: { id: query.id }})
    //this.credentialContent = credList.list[0]
    const credential = credList.list[0]
    return { credential }
  },
  methods:{
    deleteCredential: async function() {
        if(this.credential != null) {
            const delResp = await this.$axios.delete("/api/wallet/credentials/delete/" + encodeURIComponent(this.credential.id))
            this.onDelete = true;
            if(delResp.status == 200) {
                this.onDelete = false;
                this.deleted = true;
                setTimeout(() => {
                    this.$router.back()
                }, 2500);
                
            }
        }
    },
    onCopy: function(){
        const copyContent = JSON.stringify(this.credential)
        copyText(copyContent, undefined, (error, event) => {
          if (error) {
            alert('Can not copy')
            console.log(error)
          } else {
            this.coppied=true;
            console.log(event)
          }
        })
    },
    Compliance: async function() {
            this.$axios.$post(`/api/wallet/onboard/gaiax/compliance`, this.credential).then(res => {
                console.log(res)
                // let id = uuidv4()
                // console.log(res)
                // this.$axios.$post(`/issuer-api/default/config/templates/${id}`, res).then(response => {
                //     console.log(response)
                //     let payload = {
                //         template:id,
                //         did:this.$store.state.wallet.currentDid,
                //         subject:res.credentialSubject.id,
                //         verificationMethod:this.$store.state.wallet.currentDid
                //     }
                //     this.$axios.$post(`/api/wallet/selfissue/create`, payload).then(final=> {
                //         console.log(final)
                //         this.passed=true
                //     })
                // })
                this.passed=true
                
            }).catch(err =>{
                console.log(err)
                alert('Cannot pass compliance with this VC')
            }).finally(()=>{
              this.wizardNext()
            })
        },
  }
};
</script>
